/*-------------------------------------------------------
	PLUGIN/2.0 Stub
-------------------------------------------------------*/

#include "PluginStub.h"

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string>

using namespace std;

#define PLUGIN_VERSION "PLUGINSTUB/1.0"

//======================ǂݍݎ======================

BOOL load(HGLOBAL h, long len)
{
	GlobalFree(h);
	return TRUE;
}


//======================J======================

BOOL unload(void)
{
	return TRUE;
}


//======================NGXgWrapper======================
static char *RealRequest(char *pRequest,int &isAllocate);

HGLOBAL request(HGLOBAL h, long *len)
{
	char *pRequestData = (char*)malloc(*len + 1);
	if ( ! pRequestData ) { return NULL; }

	memcpy(pRequestData,h,*len);
	pRequestData[*len] = 0;

	GlobalFree(h);

	int isAllocate = FALSE;

	char *pResult = RealRequest(pRequestData,isAllocate);
	free(pRequestData);

	if ( ! pResult ) {
		pResult = "PLUGIN/2.0 204 No Content\r\nCharset: Shift_JIS\r\n\r\n";
	}

	DWORD lenResult = strlen(pResult) + 1;
	HGLOBAL hResult = GlobalAlloc(GMEM_FIXED,lenResult);
	memcpy(hResult,pResult,lenResult);
	*len = lenResult;

	if ( isAllocate ) {
		free(pResult);
	}

	return hResult;
}

//======================{request======================
//[I[eLXgԂĂ

#define STRCMP_HEAD(data,head) ( strncmp(data,head,sizeof(head) - 1) == 0 )

char *RealRequest(char *pRequest,int &isAllocate)
{
	char *pID = strstr(pRequest,"ID:");
	if ( ! pID ) { return NULL; }

	pID += 3;
	while ( *pID == ' ' ) { ++pID; } //Xy[X

	if ( STRCMP_HEAD(pID,"version") ) {
		return "PLUGIN/2.0 200 OK\r\nCharset: Shift_JIS\r\nValue: " PLUGIN_VERSION "\r\n\r\n";
	}
	else if ( STRCMP_HEAD(pID,"OnMenuExec") ) {
		return "PLUGIN/2.0 200 OK\r\nCharset: Shift_JIS\r\nScript: \\h\\s[5]ǂꂪłH\\n\\n\\q[_,genten]\\n\\q[_,dame]\\n\\q[,bomb]\\e\r\n\r\n";
	}
	else if ( STRCMP_HEAD(pID,"OnChoiceSelect") ) {
		char *pRef0 = strstr(pRequest,"Reference0:");
		if ( ! pRef0 ) { return NULL; }

		pRef0 += 11;
		while ( *pRef0 == ' ' ) { ++pRef0; } //Xy[X

		if ( STRCMP_HEAD(pRef0,"genten") ) {
			string tmp("PLUGIN/2.0 200 OK\r\nCharset: Shift_JIS\r\nTarget: Ƃイ搶\r\nScript: \\h\\s[0]\\u\\s[11]_");
			
			srand(time(NULL));
			int genten = rand() % 10;

			char tmpTxt[32];
			sprintf(tmpTxt,"%u",genten);

			tmp += tmpTxt;
			tmp += "B\\w8\\w8\\h\\s[4]B\\e";

			char *pResult = (char*)malloc(tmp.length() + 1);
			strcpy(pResult,tmp.c_str());
			isAllocate = TRUE;

			return pResult;
		}
		else if ( STRCMP_HEAD(pRef0,"dame") ) {
			string tmp("PLUGIN/2.0 200 OK\r\nCharset: Shift_JIS\r\nTarget: \r\nScript: \\u\\s[10]\\h\\s[8]_");
			
			srand(time(NULL));
			int dame = rand() % 100 + 300;

			char tmpTxt[32];
			sprintf(tmpTxt,"%u",dame);

			tmp += tmpTxt;
			tmp += "iB\\w8\\w8\\uNɐi悵Ƃ˂B\\e";

			char *pResult = (char*)malloc(tmp.length() + 1);
			strcpy(pResult,tmp.c_str());
			isAllocate = TRUE;

			return pResult;
		}
		else {
			return "PLUGIN/2.0 200 OK\r\nCharset: Shift_JIS\r\nScript: \\h\\s[4]͌łB\\e\r\n\r\n";
		}
	}

	return NULL;
}

